local addonName, a = ...
local L = a.Localize
local s = SpellFlashAddon
local c = BittensGlobalTables.GetTable("BittensSpellFlashLibrary")

local GetPowerRegen = GetPowerRegen
local GetTime = GetTime
local math = math
local pairs = pairs
local select = select

function a.FocusAdded()
	local added = 14
	if c.WearingSet(2, "T13") then
		added = 2 * added
	end
	return added
end

local function adjustCost(info)
	if c.InfoMatches(info, "Cobra Shot") then
		info.Cost = -a.FocusAdded()
	elseif c.InfoMatches(info, "Fervor") then
		info.Cost = -50
	end
end

a.Rotations = {}

function a.PreFlash()
	a.Regen = select(2, GetPowerRegen())
	if c.HasBuff("Fervor") or c.IsAuraPendingFor("Fervor") then
		a.Regen = a.Regen + 5
	end
	adjustCost(c.GetCastingInfo())
	adjustCost(c.GetQueuedInfo())
	a.Focus = c.GetPower(a.Regen)
	if c.IsCasting("Fervor") then
		a.Focus = math.min(100, a.Focus + 50)
	end
end

----------------------------------------------------------------- Beast Mastery
a.Rotations.BeastMastery = {
	Spec = 1,
	
	FlashInCombat = function()
		c.FlashAll("Focus Fire")
--c.Debug("Flash", string.format("%.1f", a.Focus),
		c.PriorityFlash(
			"Serpent Sting", 
			"Fervor",
			"Bestial Wrath",
			"Rapid Fire for BM",
			"Stampede",
			"Kill Shot",
			"Kill Command",
			"A Murder of Crows",
			"Glaive Toss",
			"Lynx Rush",
			"Dire Beast",
			"Barrage",
			"Powershot",
			"Blink Strike",
			"Readiness",
			"Arcane Shot under Thrill of the Hunt",
			"Cobra Shot for Serpent Sting",
			"Arcane Shot for BM",
			"Cobra Shot")
--)
	end,
	
	FlashAlways = function()
		c.FlashAll("Aspect of the Hawk", "Mend Pet", "Call Pet")
	end,
}

---------------------------------------------------------------------- Survival
a.Rotations.Survival = {
	Spec = 3,
	
	FlashInCombat = function()
		c.FlashAll("Rapid Fire")
--c.Debug("Flash", string.format("%.1f", a.Focus),
		c.PriorityFlash(
			"A Murder of Crows",
			"Blink Strike",
			"Lynx Rush",
			"Explosive Shot under Lock and Load",
			"Glaive Toss",
			"Powershot",
			"Barrage",
			"Serpent Sting",
			"Explosive Shot",
			"Kill Shot",
			"Black Arrow",
			"Arcane Shot under Thrill of the Hunt",
			"Dire Beast",
			"Stampede",
			"Readiness",
			"Fervor",
			"Cobra Shot for Serpent Sting",
			"Arcane Shot",
			"Cobra Shot")
--)
	end,
	
	FlashAlways = function()
		c.FlashAll("Aspect of the Hawk", "Mend Pet", "Call Pet")
	end,
}
