local addonName, a = ...

local L = a.Localize
local s = SpellFlashAddon
local c = BittensGlobalTables.GetTable("BittensSpellFlashLibrary")

a.Rotations = { }

--------------------------------------------------------------------- Elemental
a.Rotations.Elemental = {
	Spec = 1,
	
	FlashInCombat = function()
		c.FlashAll(
			"Elemental Mastery", 
			"Ascendance for Elemental",
			"Ancestral Swiftness",
			"Wind Shear")
		c.PriorityFlash(
			"Fire Elemental Totem",
			"Unleash Elements for Elemental",
			"Lava Burst",
			"Flame Shock for Elemental",
			"Elemental Blast",
			"Earth Shock for Fulmination",
			"Earth Elemental Totem",
			"Searing Totem for Elemental",
			"Lightning Bolt")
	end,
	
	FlashOutOfCombat = function()
		c.FlashAll("Thunderstorm", "Water Walking")
	end,
	
	FlashAlways = function()
		c.FlashAll(
			"Lightning Shield", 
			"Flametongue Weapon", 
			"Healing Surge when Solo")
	end,
}

------------------------------------------------------------------- Enhancement
a.Rotations.Enhancement = {
	Spec = 2,
	
	FlashInCombat = function()
		if c.IsCasting("Lightning Bolt") 
			and not c.HasBuff("Ancestral Swiftness") then
			
			a.Maelstrom = 0
		else
			a.Maelstrom = c.GetBuffStack("Maelstrom Weapon")
		end
		
		c.FlashAll(
			"Elemental Mastery", 
			"Fire Elemental Totem",
			"Ascendance", 
			"Wind Shear")
		c.PriorityFlash(
			"Searing Totem",
			"Unleash Elements with Unleashed Fury",
			"Elemental Blast",
			"Lightning Bolt at 5",
			"Stormstrike",
			"Flame Shock under Unleash Flame",
			"Lava Lash",
			"Flame Shock Overwrite under Unleash Flame",
			"Unleash Elements",
			"Lightning Bolt at 4",
			"Ancestral Swiftness under 2",
			"Lightning Bolt under Ancestral Swiftness",
			"Earth Shock",
			"Feral Spirit",
			"Earth Elemental Totem",
			"Lightning Bolt at 2")
	end,
	
	FlashOutOfCombat = function()
		c.FlashAll("Water Walking")
	end,
	
	FlashAlways = function()
		c.FlashAll(
			"Lightning Shield", 
			"Windfury Weapon", 
			"Flametongue Weapon Offhand", 
			"Healing Surge when Solo")
	end,
}

------------------------------------------------------------------- Restoration
a.Rotations.Restoration = {
	Spec = 3,
	
	FlashInCombat = function()
		c.FlashAll(
			"Wind Shear",
			"Healing Stream Totem",
			"Mana Tide Totem",
			"Lightning Bolt for Mana")
	end,
	
	FlashOutOfCombat = function()
		c.FlashAll("Water Walking")
	end,
	
	FlashAlways = function()
		c.FlashAll(
			"Earth Shield", 
			"Water Shield", 
			"Earthliving Weapon")
	end,
    
    CastSucceeded = function(info)
	    if c.InfoMatches(info, "Earth Shield") then
	        a.EarthShieldTarget = info.Target
	        c.Debug("Event", "Earth Shield target:", a.EarthShieldTarget)
	    end
    end,
}
