local addon_name, addon = ...

LibStub("AceAddon-3.0"):NewAddon(addon, addon_name, "AceEvent-3.0")

UIErrorsFrame:UnregisterEvent("UI_ERROR_MESSAGE")

local function HexToRGBPerc(hex)
	local rhex, ghex, bhex = string.sub(hex, 1, 2), string.sub(hex, 3, 4), string.sub(hex, 5, 6)
	return tonumber(rhex, 16)/255, tonumber(ghex, 16)/255, tonumber(bhex, 16)/255
end

function addon:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("ErrDB", ErrDefault, true)
	self.options = self:GetOptions()
	self.default = function() return addon:ResetOptions() end

	LibStub("AceConfig-3.0"):RegisterOptionsTable(self.name, self.options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions(self.name, self.name, nil)

	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("UI_ERROR_MESSAGE")
	self:ADDON_LOADED()
end

function addon:ResetOptions()
	ErrDB = addon:GetDefault()
	for k,v in pairs(ErrDB.ErrName) do
		v.ErrHide = ErrDB.ErrCat[v.ErrCat].ErrHide
		v.ErrColor = ErrDB.ErrCat[v.ErrCat].ErrColor
		v.ErrRdr = ErrDB.ErrCat[v.ErrCat].ErrRdr
	end
end

function addon:ADDON_LOADED(addon_name)
	default = addon:GetDefault()
	if ((not ErrDB) or (not ErrDB.version) or ErrDB.version < default.version) then
		addon:ResetOptions()
	end
end

function addon:UI_ERROR_MESSAGE(addon_name, e)
	if (ErrDB.ErrName[e] ~= nil) then
		if (not ErrDB.ErrName[e].ErrHide) then
			RedirectOutput(ErrDB.ErrName[e].ErrRdr, e, HexToRGBPerc(ErrDB.ErrName[e].ErrColor))
		end
	else
		RedirectOutput("Default", e, HexToRGBPerc("AA0000"))
	end
end